#include "network.h"

Getdata::Getdata(GMemory *mem) {
    this->mem = mem;
    _head = _tail = _num_entry = 0;
    nentry = NENTRY;
}

/**********************************************************************/
/**
 * check whether the command buffer has one or more commands or not
 * \return 0: there is no command, 1: there are one or more commands
 */
bool Getdata::isempty()
{
    return (_num_entry == 0);
}

/**********************************************************************/
/**
 * check whether the command buffer is full
 * \return 0: not full, 1: full
 */
bool Getdata::isfull()
{
    return (_num_entry == nentry);
}
bool Getdata::enq(uint064_t addr, uint032_t size) {
    if (isfull()) {
        printf("## Enqueue is failed. Getdata is full.\n");
        return false;
    }
    else {
        for(uint032_t i = 0; i < size/4; i++) {
            mem->read4b(addr + i*4,
                        getdata[_tail].data + i);
        }
        getdata[_tail].size = size;
        getdata[_tail].read_addr = addr;
        getdata[_tail].read_idx = 0;
        _tail = (_tail == nentry - 1) ? 0 : _tail + 1;
        _num_entry++;
        return true;
    }
}

bool Getdata::deq()
{
    if (isempty()) {
        printf("## Dequeue is failed. Getdata is empty.\n");
        return false;
    }
    else {
        _head = (_head == nentry - 1) ? 0: _head + 1;
        _num_entry--;
        return true;
    }
    return true;
}

uint032_t Getdata::nextdata() {
    if(getdata[_head].read_idx*4 >= getdata[_head].size)
        deq();

    if(getdata[_head].read_idx >= getdata[_head].size) {
        fprintf(stderr, "nextdata() error, _head:%d idx:%d size:%d\n",
                _head, getdata[_head].read_idx, getdata[_head].size);
        exit(1);
        return 0;
    }
    else {
        uint032_t data = getdata[_head].data[getdata[_head].read_idx];
        getdata[_head].read_addr ++;
        getdata[_head].read_idx ++;
        return data;
    }
}

