/**********************************************************************/
/* Many-Core Architecture Research Project       Arch Lab. TOKYO TECH */
/**********************************************************************/
#include "network.h"

/**********************************************************************/
/**
 * show usage
 */
void usage()
{
    static const char *usagemessage = "\
  -b[idx]_[idy]_[object_file_name]: set a binary that core(idx, idy) execute\n\
  -e[num][kmg]: stop simulation after num cycles executed \n\
  -d[level]: debug mode \n\
  -q: quiet mode \n\
  -x[num]: number of colum \n\
  -y[num]: number of row \n\
  -A: add one row for server cores (env->add_row_flag=1, default)\n\
  -B: without one row for server cores (env->add_row_flag=0)\n\
  -O[idx]_[idy]_[option]: set option to core(idx, idy)\n\
  -D[num]: network information display option \n\
    -D0: default, print nothing \n\
    -D1: print packet sent/recieved log\n\
    -D2: print simple view ??? \n\
    -D4: show flitview (with CURSES library) recommended.\n\
    -D4_logfile: output log file for flitview\n\
  --del_module: delete memory node, path node\n\
  --del_server: delete server node. same as -B\n\
  --help: display this help\n\
  --version: display version\n\
sample: \n\
  SimMc -x8 -y8 -D4 test.out \n\
  SimMc -b2_2_test2.out test.out \n\
";

    printf("## %s %s\n", MC_NAME, MC_VER);
    printf("## [%s %s]\n", L_NAME, L_VER);
    
    printf("Usage: SimMc [-option] object_file_name \n");
    printf("%s", usagemessage);
    exit(0);
}

void testhit(GMemory *gmem, uint064_t addr) {
    int result = gmem->pagehit(addr);
    printf("%016llx %d\n", addr, result);
}

/**********************************************************************/
/**
 * main
 */
int main(int argc, char *argv[])
{
#if 0
    GMemory gmem;
    

    for(int i = 0; i < 15; i++)
        testhit(&gmem, 0x12340000);
    testhit(&gmem, 0x1234000c);

    for(int i = 0; i < 15; i++)
        testhit(&gmem, 0x4000000);

    
    return 0;

#else
    Env *env = new Env();
    
    // execute if successfully initialized
    if (env->initialize(argc, argv) == 0) {
        env->execute();
        env->finalize();
    }
    
    delete env;
    return 0;
#endif
}

/**********************************************************************/
